
function App(data) {
	let elem;
  const store = data.store;

	let list = [];
  let listElem;

	let pushButtonElem;
	let unshiftButtonElem;

	function construct() {
    elem = document.createElement('div');
		elem.id = data.id || 'app';
		{
			pushButtonElem = document.createElement('button');
			pushButtonElem.style.marginRight = '8px';
			pushButtonElem.innerHTML = 'push()';
			pushButtonElem.onclick = function() { data.onPushButtonClicked && data.onPushButtonClicked(); }
			elem.appendChild(pushButtonElem);

			unshiftButtonElem = document.createElement('button');
			unshiftButtonElem.innerHTML = 'unshift()';
			unshiftButtonElem.onclick = function() { data.onUnshiftButtonClicked && data.onUnshiftButtonClicked(); }
			elem.appendChild(unshiftButtonElem);

			elem.appendChild(document.createElement('hr'));

      listElem = document.createElement('div');
			listElem.className = 'list';
			elem.appendChild(listElem);
    }
		bind();
		update();
  }

	function update() {
		updateList(store.getList(), list, listElem,
			(ref) => {
				const component = new Item({});
				component.data.onClick = function() { component.exit(); }
				component.data.onExited = function() { store.removeFromList(ref); }
				return component;
			},
			(component, ref) => {
				if(component.data.text != ref.value) {
					component.data.text = ref.value;
					component.update();
				}
			},
		);
	}

	function enter() {}
	function exit() {}

	function destroy() {}

	////////////////////////////////////////////////////////////////

	function bind() {
		store.on('list', update);
	}
	function unbind() {
		store.off('list', update);
	}

	////////////////////////////////////////////////////////////////

	construct();
	return { elem, data, update, enter, exit, destroy };

	////////////////////////////////////////////////////////////////

	////////////////////////////////
	// list rendering
	function updateList(storeList, list, listElem, componentCreate, componentUpdate) {
		const slots = new Array(storeList.length);
		// flush list into slots, remove items marked as removed
		while(list.length) {
			const item = list.shift();
			if(item.data.ref.removed) {
				listElem.removeChild(item.elem);
				item.destroy();
				continue;
			}
			slots[item.data.ref.i] = item;
		}
		// componentCreate for empty slots, repopulate list, mount unmounted items
		for(let i = 0; i < slots.length; i++) {
			if(!slots[i]) {
				const ref = storeList[i];
				slots[i] = componentCreate(ref);
				slots[i].data.ref = ref;
			}
			const component = list[i] = slots[i];
			if(!component.data.mounted) {
				listElem.insertBefore(component.elem, listElem.childNodes[i+1]);
				component.enter();
				component.data.mounted = true;
			}
		}
		// sort elements, call componentUpdate
		for(let i = 0; i < list.length; i++) {
			const component = list[i];
			if(listElem.childNodes[i] != component.elem) {
				listElem.insertBefore(component.elem, listElem.childNodes[i+1]);
			}
			componentUpdate(component, component.data.ref);
		}
	}
	////////////////////////////////

}
