
function Item(data) {
	let elem;

	function construct() {
		new Item.Css({});
    elem = document.createElement('div');
		elem.className = 'item';
		elem.style.maxHeight = 0;
		bind();
		update();
  }

	function update() {
		elem.innerHTML = data.text;
	}

	function enter() {
		nextFrame(() => {
			elem.style.maxHeight = elem.scrollHeight + 'px';
		});
	}
	function exit() {
		elem.style.maxHeight = 0;
	}

	function destroy() {}

	////////////////////////////////////////////////////////////////

	function onClick(e) {
		if(e && e.srcElement == elem) {
			data.onClick && data.onClick(e);
		}
	}

	function onTransitionEnd(e) {
		if(e && e.srcElement == elem) {
			if(elem.style.maxHeight === elem.scrollHeight + 'px') { data.onEntered && data.onEntered(); }
			else { data.onExited && data.onExited(); }
		}
	}

	////////////////////////////////////////////////////////////////

	function bind() {
		elem.addEventListener('click', onClick);
		elem.addEventListener('transitionend', onTransitionEnd);
	}
	function unbind() {
		elem.removeEventListener('click', onClick);
		elem.removeEventListener('transitionend', onTransitionEnd);
	}

	////////////////////////////////////////////////////////////////

	construct();
	return { elem, data, update, enter, exit, destroy };

	////////////////////////////////////////////////////////////////

	function nextFrame(handler) {
		window.requestAnimationFrame && requestAnimationFrame(function() {
			requestAnimationFrame(function() {
				handler();
			});
		});
	}

}

Item.Css = function(data) {
  let elem;
  data.cssId = data.cssId || 'css-item';

  function construct() {
    elem = document.getElementById(data.cssId);
    if(!elem) {
      elem = document.createElement('style');
      elem.id = data.cssId;
      update();
    }
  }

  function update() {
    elem.innerHTML = `
      .item {
				line-height: 30px;
				padding-left: 4px;
				border-radius: 5px;
				border: 1px solid gray;
				background-color: lightgray;
				overflow: hidden;
				cursor: pointer;
				transition: all 0.4s;
				max-width: 400px;
      }
    `;
  }

  if(!Item.Css[data.cssId]) {
    construct();
    Item.Css[data.cssId] = { elem, data, update };
    document.head.appendChild(elem);
  }
  return Item.Css[data.cssId];
}
