/*!
 * Duck unframework used in this codebase.
 * Duck
 * (c) 2020 Tom Knapp-Ramos
 * Released under the MIT License.
 */

////////////////////////////////////////////////////////////////
// main

const store = new Store({
  text: 'Starter',
  list: [
    { value: 'Item 1' },
    { value: 'Item 2' },
    { value: 'Item 3' },
    { value: 'Item 4' },
    { value: 'Item 5' },
  ],
});

let app = mount('app');
// let app2 = mount('app2');

////////////////////////////////////////////////////////////////
// utils

function mount(id) {
  const app = new App({
    id,
    store,
  });
  app.data.onPushButtonClicked = push;
  app.data.onUnshiftButtonClicked = unshift;
  document.body.insertBefore(app.elem, document.body.childNodes[0]);
  app.enter();
  return app;
}

let c = 6;

function push() {
  store.pushToList({ value: `Item ${c}` });
  c++;
}

function unshift() {
  store.unshiftToList({ value: `Item ${c}` });
  c++;
}
