
function Store(data) {
  const events = {};

  let list = data.list || [];
  indexList(list);

  ////////////////////////////////////////////////////////////////

  function getList() { return list; }
  function setList(values) {
    if(values) { list = values; }
    indexList(list);
    emit('list');
  }
  function pushToList(item) {
    list.push(item);
    setList();
  }
  function unshiftToList(item) {
    list.unshift(item);
    setList();
  }
  function removeFromList(item) {
    item.remove = true;
    setList();
  }
  function shuffleList() {
    shuffleArray(list);
    setList();
  }

  ////////////////////////////////////////////////////////////////

  return {
    getList,
    setList,
    pushToList,
    unshiftToList,
    removeFromList,
    shuffleList,
    on, off
  };

  ////////////////////////////////
  // events
  function on(name, handler) {
    if(!events[name]) { events[name] = []; }
    events[name].push(handler);
  }
  function off(name, handler) {
    if(events[name]) {
      const index = events[name].indexOf(handler);
      if(index != -1) { events[name].splice(index, 1); }
    }
  }
	function emit(name, value) {
		if(events[name]) {
			for(let i = 0; i < events[name].length; i++) {
				events[name][i](value);
			}
		}
	}
	////////////////////////////////

  ////////////////////////////////
  // list rendering
  function indexList(list) {
    for(let i = 0; i < list.length; i++) {
      // remove items marked for removal
      if(list[i].remove) {
        list.splice(i, 1)[0].removed = true;
        i--;
        continue;
      }
      // apply index
      list[i].i = i;
    }
  }
  ////////////////////////////////

  ////////////////////////////////////////////////////////////////
  // utils

  function shuffleArray(array) {
    for (let i = array.length - 1; i > 0; i--) {
      let j = Math.floor(Math.random() * (i + 1));
      let temp = array[i];
      array[i] = array[j];
      array[j] = temp;
    }
  }

}
